@echo off
chcp 1252 >nul 2>nul
color f0

cls
echo ==============================================================================
echo Factory Image Flasher for Nexus/Pixel by TimeTurn ---- Last change: 2017-04-07
echo ------------------------------------------------------------------------------
echo INSTRUCTIONS: Extract Factory Image to the folder of this script, but DO NOT
echo               extract image-^<codename^>-^<version^>.zip! Place TWRP image into
echo               the folder if it should be flashed afterwards. Bootloader and
echo               radio are detected automatically. Delete them if you don't want
echo               them to be flashed or replace them.
echo ==============================================================================
echo.

del "%~dp0\flash-*.*" >nul 2>nul
del "%temp%\flash*.txt" >nul 2>nul

dir /b "%~dp0\bootloader*.img" >"%temp%\flash-bootloader.txt" 2>nul
dir /b "%~dp0\radio*.img" >"%temp%\flash-radio.txt" 2>nul
dir /b "%~dp0\image-*.zip" >"%temp%\flash-image.txt" 2>nul
dir /b "%~dp0\twrp-*.img" >"%temp%\flash-twrp.txt" 2>nul

set /p bl= <"%temp%\flash-bootloader.txt" >nul 2>nul
set /p rd= <"%temp%\flash-radio.txt" >nul 2>nul
set /p im= <"%temp%\flash-image.txt" >nul 2>nul
set /p tw= <"%temp%\flash-twrp.txt" >nul 2>nul

del "%temp%\flash*.txt" >nul 2>nul

if not "%bl%"=="" set bootloader=%~dp0\%bl%
if not "%rd%"=="" set radio=%~dp0\%rd%
if not "%im%"=="" set image=%~dp0\%im%
if not "%tw%"=="" set twrp=%~dp0\%tw%

if exist=="%image%" goto image_ok

:image_err
echo ERROR: No factory image found. Press any key to end script
goto goout

:image_ok
echo Image........: %im%

if exist=="%bootloader%" (echo Bootloader...: %bl%) else (echo Bootloader...: ^<none^>)
if exist=="%radio%" (echo Radio........: %rd%) else (echo Radio........: ^<none^>)
if exist=="%twrp%" (echo TWRP.........: %tw%) else (echo TWRP.........: ^<none^>)

echo.
echo Ready to flash. Boot Phone into Bootloader and press any key to start.
pause >nul

if exist=="%bootloader%" (
	echo.
	echo Flashing bootloader "%bl%"...
	fastboot flash bootloader "%bootloader%"
	fastboot reboot-bootloader >nul 2>nul
)

if exist=="%radio%" (
	echo.
	echo Flashing radio "%rd%"...
	echo.
	fastboot flash radio "%radio%"
	fastboot reboot-bootloader >nul 2>nul
)

echo.
set /p wipe="Ready to flash main image. Wipe while flashing? [Y/N] -> "

echo.
if %wipe%==y (
	set wipeswitch=-w
	echo Wipe activated. Phone will be completely wiped inlcluding internal memory.
) else (
	echo Wipe not activated. Phone data will be left intact.
)
echo.
echo Note that loading the image to the phone needs some time, so please be patient.
echo.
fastboot %wipeswitch% update "%image%"

if exist=="%twrp%" (
	echo.
	echo System should be booting right now.
	echo.
	echo To flash "%tw%", wait till boot
	echo has finished and reboot manually to bootloader.
	echo.
	fastboot flash recovery "%twrp%"
)

echo.
echo All done.

:goout
echo.
echo Press any key to end.
pause >nul
